

-- Setup Tables
if loooser==nil then loooser={} end
loooser.fence={}
loooser.fence.object={}

-- Load & Prepare Ressources

        loooser.fence.gfx_wpn=loadgfx("buildings/block.bmp")
        setmidhandle(loooser.fence.gfx_wpn)                                         -- Weapon Image
loooser.fence.sfx_build=loadsfx("buildmetal.ogg")
loooser.fence.sfx_bounce=loadsfx("bounce.wav")                                                                         -- Build Sound

--------------------------------------------------------------------------------
-- Weapon: Bar
--------------------------------------------------------------------------------

loooser.fence.id=addweapon("loooser.fence","Fence",loooser.fence.gfx_wpn,3)                                                -- Add Weapon (3 uses)

function loooser.fence.draw()                                                                                                                -- Draw
        if weapon_shots==0 then
                -- HUD Positioning
                hudpositioning(pos_build,loooser.fence.gfx_wpn)
        end
end

function loooser.fence.attack(attack)                                                                                                -- Attack
        if weapon_timer>0 then
                weapon_timer=weapon_timer-1
        end
        if (weapon_shots<=0) and (attack==1) and (weapon_timer==0) then
                -- Rotate
                weapon_timer=15
                weapon_mode=weapon_mode+1
                if weapon_mode>1 then
                        weapon_mode=0
                end
        end
        if (weapon_shots<=0) and (weapon_position==1) then
                -- Use weapon and allow to use another one afterwards (1)
                useweapon(1)
                weapon_shots=weapon_shots+1
                -- Draw
                createobject(loooser.fence.object.id,weapon_x,weapon_y)
                -- Sound
                playsound(loooser.fence.sfx_build)
        end
end

--object------------------------------------------------------------------
loooser.fence.object.id=addobject("loooser.fence.object",loooser.fence.gfx_wpn)                        -- Add Object

function loooser.fence.object.setup(id,parameter)
        if objects==nil then objects={} end
        objects[id]={}
        objects[id].sy=0
        objects[id].timer=0
        objects[id].health=100
end

function loooser.fence.object.draw(id,x,y)
        -- Setup draw mode
        setblend(blend_alpha)
        setalpha(1)
        setcolor(255,255,255)
        setscale(1,1)
        setrotation(0)
        -- Draw
        drawimage(loooser.fence.gfx_wpn,x,y)
end

function loooser.fence.object.update(id,x,y)
        -- Gravity influence on speed
        objects[id].sy=objects[id].sy+getgravity()
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.abs(objects[id].sy)/15)
        msuby=objects[id].sy/msubt
        for i=1,msubt,1 do
                y=y+msuby
                -- Collision
                if collision(loooser.fence.gfx_wpn,x,y,1,1,1,-1,id)==1 then
                        if (math.abs(objects[id].sy)>0.5) then playsound(loooser.fence.sfx_bounce) end
                        y=y-msuby
                        objects[id].sy=-objects[id].sy*0.3
                        msuby=-msuby*0.3
                end
                -- Water
                if y>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,x,y)
                        playsound(sfx_hitwater1)
                        -- Remove
                        removeobject(id)
                        return
                end
        end
        objectposition(id,x,y)

end

function loooser.fence.object.damage(id,damage)
if objects[id].health>0 then
                objects[id].health=objects[id].health-damage
                if objects[id].health<=0 then
                        -- Remove
                        removeobject(id)
                 end
end
end
