

-- Setup Tables
if loooser==nil then loooser={} end
loooser.zombie={}
loooser.zombie.zombie={}
loooser.zombie.sfx_attack={}
loooser.zombie.sfx_attack2={}

-- Load & Prepare Ressources
loooser.zombie.gfx_wpn0=loadgfx("players/zombie1.png")                                -- Weapon Image Frame 0
setmidhandle(loooser.zombie.gfx_wpn0)
loooser.zombie.gfx_wpn1=loadgfx("players/zombie2.png")                                -- Weapon Image Frame 1
setmidhandle(loooser.zombie.gfx_wpn1)
for i = -1,1 do
loooser.zombie.sfx_attack[i]=loadsfx("zombie"..i..".wav")                                                -- Attack Sound
end
for b=1,3 do
loooser.zombie.sfx_attack2[b]=loadsfx("stone"..b..".wav")
end


--------------------------------------------------------------------------------
-- Projectile: Hitler
--------------------------------------------------------------------------------

loooser.zombie.zombie.id=addobject("loooser.zombie.zombie",loooser.zombie.gfx_wpn0)                -- Add Projectile

function loooser.zombie.zombie.setup(id,parameter)
        if objects==nil then objects={} end
        objects[id]={}
        objects[id].health=100
        objects[id].sy=0
        objects[id].sx=0
        objects[id].dir=1
        objects[id].timer=0
        objects[id].frame=0
end

function loooser.zombie.zombie.draw(id,x,y)
        -- Setup draw mode
        setblend(blend_alpha)
        setalpha(1)
        setrotation(180)
        setcolor(255,255,255)
        setscale(objects[id].dir,-1)
        -- Draw projectile
        if objects[id].frame==0 then
                drawimage(loooser.zombie.gfx_wpn0,x,y-2)
        else
                drawimage(loooser.zombie.gfx_wpn1,x,y-2)
        end

end

function loooser.zombie.zombie.update(id,x,y)
         if objects[id].health<0 then
                 particle(p_bodypart,x,y)
                 particlecolor(0,53,20)
                 for i = 1,3 do
                         particle(p_bigblood,x,y)
                 end
                 playsound(loooser.zombie.sfx_attack[-1])
                 removeobject(id)
                 return
         end
         if getplayerx(0)>x then
                 objects[id].dir=-1
         else
                 objects[id].dir=1
         end
        -- Animation
        objects[id].timer=objects[id].timer+1
        if objects[id].timer>19 then
                objects[id].timer=0
                objects[id].frame=1-objects[id].frame
                if objects[id].frame==1 then
                        -- scream
                        if math.random(1,100)==1 then
                        playsound(loooser.zombie.sfx_attack[math.random(0,1)])
                        end
                        -- Punch Players
                        if collision(col20x20,x-objects[id].dir*11,y-5,0,1,1,-1,id)==1 then
                                if playercollision()~=0 then
                                        playerpush(playercollision(),-objects[id].dir*3,-10)
                                        playerdamage(playercollision(),5)
                                        playsound(sfx_splatter1)
                                        particle(p_ring,getplayerx(playercollision()),getplayery(playercollision()))
                                        particlecolor(255,0,0)
                                        blood(getplayerx(playercollision()),getplayery(playercollision()))
                                end
                                if objectcollision()~=id and getobjecttype(objectcollision())==loooser.fence.object.id then
                                        objectdamage(objectcollision(),5)
                                        playsound(loooser.zombie.sfx_attack2[math.random(1,3)])
                                end
                        end
                end
        end
        -- Move Left/Right
        if collision(col20x20,x-objects[id].dir*11,y-5,0,1,1,-1,id)==0 then
         x=x-objects[id].dir*0.5
        end
        if collision(colplayer,x,y,1,1,1,-1,id)==1 then
                if terraincollision()==1 or objectcollision()>0 then
                        -- Upwards/Downwards space?
                        doturn=1
                        for i=1,6,1 do
                                if (i%2)==1 then offset=(i+1)/2 else offset=-(i/2) end
                                if collision(colplayer,x,y+offset,1,1,1,-1,id)==0 then
                                        doturn=0; y=y+offset; break
                                elseif terraincollision()==0 and objectcollision()==0 then
                                        doturn=0; y=y+offset; break
                                end
                        end
                        if doturn==1 then
                                -- Move Back / Turn
                                x=x-objects[id].dir*0.5
                        end
                end
        end
        -- Fall Down
        objects[id].sy=objects[id].sy+getgravity()
        msubt=math.ceil(math.abs(objects[id].sy)/3)
        msuby=objects[id].sy/msubt
        msubx=objects[id].sx/msubt
        for i=1,msubt,1 do
                y=y+msuby
                x=x+msubx
                -- Collision
                if collision(colplayer,x,y,1,1,1,-1,id)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision~=0 then
                                objects[id].sy=0
                                y=y-msuby
                                break
                        end
                end
                -- Water
                if (y)>getwatery()-30 then
                        -- Effects
                        particle(p_waterhit,x,y)
                        playsound(sfx_hitwater3)
                        -- Free projectile
                        removeobject(id)
                        -- End Turn
                        endturn()
                        return
                end
        end
        objectposition(id,x,y)
end

function loooser.zombie.zombie.damage(id,damage)
        objects[id].health=objects[id].health-damage
        particle(p_bigblood,getobjectx(id),getobjecty(id))
end